<?php
// Exit if accessed directly
if (!defined('ABSPATH')) {
    exit;
}
 
// Custom form handlers for blacklist and whitelist editors
// @since 1.4.0

// add to whitelist
add_action( 'admin_post_whitelist_add', 'whitelist_add' );
function whitelist_add() {
    if(isset($_POST['add'])) {
        $add = $_POST['add'];
        $date = date('Y/m/d H:i:s');
        $identifier = '#Added via' . ' ' . get_bloginfo( 'name' ) . ' ' . 'at' . ' ' . date('Y/m/d H:i:s');
        $args = array(
            'method' => 'POST',
            'timeout' => '5',
            'httpversion' => '1.1',
            'blocking' => true,
            'headers' => array(),
            'body' => array(
                 'data' => $add . ' ' . $identifier,
             ),
            'cookies' => array()
        );
        $response = wp_remote_post('https://proxycheck.io/dashboard/whitelist/add/?key=' . get_option('pvb_proxycheckio_API_Key_field'), $args);
        $Decoded_JSON = json_decode(wp_remote_retrieve_body( $response ));
        if ( $Decoded_JSON->success ) {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_whitelist&add=yes&success=yes'));
        } else {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_whitelist&add=yes&success=no'));
        }
     }
}

//remove from whitelist
add_action( 'admin_post_whitelist_remove', 'whitelist_remove' );
function whitelist_remove() {
     if(isset($_POST['remove'])) {
        $remove = $_POST['remove'];
        $args = array(
            'method' => 'POST',
            'timeout' => '5',
            'httpversion' => '1.1',
            'blocking' => true,
            'headers' => array(),
            'body' => array(
                 'data' => $remove,
             ),
            'cookies' => array()
        );
        $response = wp_remote_post('https://proxycheck.io/dashboard/whitelist/remove/?key=' . get_option('pvb_proxycheckio_API_Key_field'), $args);
        $Decoded_JSON = json_decode(wp_remote_retrieve_body( $response ));
        if ( $Decoded_JSON->success ) {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_whitelist&remove=yes&success=yes'));
        } else {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_whitelist&remove=yes&success=no'));
        }
     }
}

// add to blacklist
add_action( 'admin_post_blacklist_add', 'blacklist_add' );
function blacklist_add() {
    if(isset($_POST['add'])) {
        $add = $_POST['add'];
        $date = date('Y/m/d H:i:s');
        $identifier = '#Added via' . ' ' . get_bloginfo( 'name' ) . ' ' . 'at' . ' ' . date('Y/m/d H:i:s');
        $args = array(
            'method' => 'POST',
            'timeout' => '5',
            'httpversion' => '1.1',
            'blocking' => true,
            'headers' => array(),
            'body' => array(
                 'data' => $add . ' ' . $identifier,
             ),
            'cookies' => array()
        );
        $response = wp_remote_post('https://proxycheck.io/dashboard/blacklist/add/?key=' . get_option('pvb_proxycheckio_API_Key_field'), $args);
        $Decoded_JSON = json_decode(wp_remote_retrieve_body( $response ));
        if ( $Decoded_JSON->success ) {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_blacklist&add=yes&success=yes'));
        } else {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_blacklist&add=yes&success=no'));
        }
     }
}

//remove from blacklist
add_action( 'admin_post_blacklist_remove', 'blacklist_remove' );
function blacklist_remove() {
     if(isset($_POST['remove'])) {
        $remove = $_POST['remove'];
        $args = array(
            'method' => 'POST',
            'timeout' => '5',
            'httpversion' => '1.1',
            'blocking' => true,
            'headers' => array(),
            'body' => array(
                 'data' => $remove,
             ),
            'cookies' => array()
        );
        $response = wp_remote_post('https://proxycheck.io/dashboard/blacklist/remove/?key=' . get_option('pvb_proxycheckio_API_Key_field'), $args);
        $Decoded_JSON = json_decode(wp_remote_retrieve_body( $response ));
        if ( $Decoded_JSON->success ) {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_blacklist&remove=yes&success=yes'));
        } else {
            wp_redirect(admin_url('admin.php?page=proxy_vpn_blocker_blacklist&remove=yes&success=no'));
        }
     }
}

?>